import CellNoise.*;
import processing.opengl.*;
import processing.video.*;
import javax.media.opengl.*;

import ddf.minim.*;
import ddf.minim.signals.*;

import ddf.minim.analysis.*;
import ddf.minim.effects.*;

Minim minim;
AudioOutput out;
SineWave s1;
SineWave s2;
SineWave s3;
SineWave s4;
SineWave s5;

int c;
float r;



Capture video;
PGraphicsOpenGL pgl;
GL gl;

float a = 100;                                       

double[] at = {0, 0, 0};                             
CellDataStruct cd;
CellNoise cn;

int phase1 = 1;
int phase2 = 2;
int sec = 0;
int currentphase = phase1;

boolean bg = false;                                  

int DIMENSION = 5;                                   

Box[] boxes = new Box[(int)pow((DIMENSION*2)+1,3)];  

ArrayList connectors;                                

void setup()
{
  
    minim = new Minim(this);
  out = minim.getLineOut(Minim.STEREO, 2048);
s1 = new SineWave(1, .75, out.sampleRate());
s2 = new SineWave(1, .25, out.sampleRate());
s3 = new SineWave(1, .25, out.sampleRate());
s4 = new SineWave(1, .25, out.sampleRate());
s5 = new SineWave(1, .5, out.sampleRate());

  out.addSignal(s1);
  out.addSignal(s2);
  out.addSignal(s3);
  out.addSignal(s4);


  
  c=0;
  r=random(3);
  
  
  background(0);
  smooth();
  cn = new CellNoise(this);
  cd = new CellDataStruct(this, 3, at, cn.QUADRATIC);
  
  for(int i=-DIMENSION;i<DIMENSION;i++)
  {
    for(int j=-DIMENSION;j<DIMENSION;j++)
    {
      for(int k=-DIMENSION;k<DIMENSION;k++)
      {
        at[0] = i;
        at[1] = j;
        at[2] = k+frameCount*0.01;
        cd.at = at;
        cn.noise(cd);
        boxes[(i+DIMENSION)*(DIMENSION*2+1)*(DIMENSION*2+1) + (j+DIMENSION)*(DIMENSION*2+1) + (k+DIMENSION)] = new Box(i,j,k,color((float)(cd.F[0]/2*255)),3.5);
      }
    }
  }
 
 connectors = new ArrayList(); 

try {
quicktime.QTSession.open();
} catch (quicktime.QTException qte) {
qte.printStackTrace();
}
  size(1024, 768,OPENGL);
  pgl = (PGraphicsOpenGL) g;
  gl = pgl.gl;
  frameRate(30);

  video = new Capture(this, width, height, 30);
}
void draw()
{
sec = second();
if(sec%5 == 0){
  if(currentphase == phase1){ currentphase = phase2;}
  else if(currentphase == phase2){ currentphase = phase1;}
}
if(currentphase == phase1){
  at[0] += 0.01;
  at[1] += 0.02;
  at[2] = frameCount*0.03;
  cd.at = at;
  cn.noise(cd);
  
  float damp =(float)cd.F[0]/4;
  a = a* (1-damp)+ (damp)*((float)cd.F[1]/2*400-80);

  if(bg)
    background(0);
  else background(255);
  if(random(1)>0.99)
  {
    bg = !bg;
  }
  
  for(int i=0;i<3;i++)
  connectors.add(new Connector());
  pushMatrix();
  translate(width/2,height/2);
  rotateX(frameCount*0.01);
  rotateY(frameCount*0.015);
  rotateZ(frameCount*0.025);
  
  for(int i=0;i<boxes.length;i++)
  {
    if(boxes[i] != null)
    boxes[i].update();
  }
  
  ArrayList templist = new ArrayList();
  for(int i=0;i<connectors.size();i++)
  {
    Connector temp = (Connector)connectors.get(i);
    if(!temp.complete)
    {
      temp.update();
      templist.add(temp);
    }
  }
  connectors = templist;
  
  popMatrix();
  
}
if(currentphase == phase2){ 
    noFill();
  lights();
 strokeWeight(4);
  background(0);
  if (video.available()) {
    video.read();
    video.loadPixels();
    pgl.beginGL();
    gl.glDisable(GL.GL_DEPTH_TEST);
    gl.glEnable(GL.GL_BLEND);
    gl.glBlendFunc(GL.GL_SRC_ALPHA,GL.GL_ONE);
    pushMatrix();
    translate(width, height, 0);
    translate(-width, -height, 0);
    int index = 0;
    for (int y = 0; y < video.height; y+=5) {
      beginShape();
      for (int x = 0; x < video.width; x++) {
        int pixelValue = video.pixels[x+(y*video.width)];
        vertex (x*2, y*2, (brightness(pixelValue)*2)-100);
        index++;
      }
      endShape();
    }
    pgl.endGL();
    popMatrix();
  }
}
if (r<1){
if(c<=20){ 
   s1.setFreq(277); 
   s2.setFreq(350);
   s3.setFreq(415);
   s4.setFreq(466);
   s5.setFreq(469); 


}
else if (c<=40){
s1.setFreq(293); 
    s2.setFreq(370);
    s3.setFreq(440);
   s4.setFreq(493);
   s5.setFreq(496);

}
else if (c<=60){
    s1.setFreq(330); 
    s2.setFreq(415);
    s3.setFreq(493);
   s4.setFreq(554);
   s5.setFreq(557);
 
}
else if (c<=80){
s1.setFreq(293); 
    s2.setFreq(370);
    s3.setFreq(440);
   s4.setFreq(493);
   s5.setFreq(496);
   
}

else if (c<=100){
   s1.setFreq(330); 
    s2.setFreq(415);
    s3.setFreq(493);
   s4.setFreq(554);
   s5.setFreq(557);
      
}
else if (c<120){
s1.setFreq(293); 
    s2.setFreq(370);
    s3.setFreq(440);
   s4.setFreq(493);
   s5.setFreq(496);
  
}
else if (c<=140){
    s1.setFreq(277); 
   s2.setFreq(350);
   s3.setFreq(415);
   s4.setFreq(466);
    s5.setFreq(469); 
    
}
else if(c<=157){
  c=0;
  r=random(3);
}}


else if(r<2){
  if(c<=15){ 
   s1.setFreq(262); 
   s2.setFreq(330);
   s3.setFreq(392);
   s4.setFreq(440);
  s5.setFreq(442); 
}
else if (c<=30){
s1.setFreq(293); 
    s2.setFreq(370);
    s3.setFreq(440);
   s4.setFreq(493);
   s5.setFreq(495);
}
else if (c<=45){
    s1.setFreq(330); 
    s2.setFreq(415);
    s3.setFreq(493);
   s4.setFreq(554);
   s5.setFreq(556);
}
else if (c<=60){
    s1.setFreq(393); 
    s2.setFreq(493);
    s3.setFreq(587);
   s4.setFreq(659);
   s5.setFreq(661);
}

else if (c<=75){
   s1.setFreq(330); 
    s2.setFreq(415);
    s3.setFreq(493);
   s4.setFreq(554);
   s5.setFreq(556);
}

else if(c<=120){
  c=0;
  r=random(3);
}}

else if(r<3){
    if(c<=10){ 
   s1.setFreq(262); 
   s2.setFreq(330);
   s3.setFreq(392);
   s4.setFreq(440);
  s5.setFreq(442);
 
}
else if (c<=20){
s1.setFreq(293); 
    s2.setFreq(370);
    s3.setFreq(440);
   s4.setFreq(493);
   s5.setFreq(495);
}
else if (c<=25){
    s1.setFreq(330); 
    s2.setFreq(415);
    s3.setFreq(493);
   s4.setFreq(554);
   s5.setFreq(556);
}
else if (c<=35){
    s1.setFreq(393); 
    s2.setFreq(493);
    s3.setFreq(587);
   s4.setFreq(659);
   s5.setFreq(661);
}

else if (c<=45){
   s1.setFreq(330); 
    s2.setFreq(415);
    s3.setFreq(493);
   s4.setFreq(554);
   s5.setFreq(556);
}

else if(c<=120){
  c=0;
  r=random(3);
}

}
c++;
}
